
macro_rules! quote {
    () => { ::proc_macro::TokenStream::new() };
    ($($t:tt)*) => {
        [
            $(::proc_macro::TokenStream::from(__quote_token_stream!($t)),)*
        ].into_iter().collect::<::proc_macro::TokenStream>()
    };
}

macro_rules! __quote_token_stream {
    ((@ $tt:tt)) => { $tt.clone() };
    (+=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('+', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (+=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('+', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (&&) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('&', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('&', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (&=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('&', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (^=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('^', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (::) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new(':', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new(':', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (/=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('/', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (..) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('.', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('.', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (...) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('.', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('.', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('.', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (..=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('.', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('.', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (==) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (>=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('>', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (<=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('<', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (*=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('*', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (!=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('!', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (|=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('|', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (||) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('|', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('|', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (->) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('-', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('>', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (<-) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('<', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('-', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (%=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('%', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (=>) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('>', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (<<) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('<', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('<', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (<<=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('<', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('<', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (>>) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('>', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('>', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (>>=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('>', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('>', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    (-=) => {
        [
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('-', ::proc_macro::Spacing::Joint)),
            ::proc_macro::TokenTree::from(::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone)),
        ].into_iter().collect::<TokenStream>()
    };
    ($tt:tt) => { ::proc_macro::TokenTree::from(__quote_token_tree!($tt)) };
}

macro_rules! __quote_token_tree {
    (($($tt:tt)*)) => { ::proc_macro::Group::new(::proc_macro::Delimiter::Parenthesis, quote!($($tt)*)) };
    ([$($tt:tt)*]) => { ::proc_macro::Group::new(::proc_macro::Delimiter::Bracket, quote!($($tt)*)) };
    ({$($tt:tt)*}) => { ::proc_macro::Group::new(::proc_macro::Delimiter::Brace, quote!($($tt)*)) };
    (,) => { ::proc_macro::Punct::new(',', ::proc_macro::Spacing::Alone) };
    (.) => { ::proc_macro::Punct::new('.', ::proc_macro::Spacing::Alone) };
    (;) => { ::proc_macro::Punct::new(';', ::proc_macro::Spacing::Alone) };
    (!) => { ::proc_macro::Punct::new('!', ::proc_macro::Spacing::Alone) };
    (<) => { ::proc_macro::Punct::new('<', ::proc_macro::Spacing::Alone) };
    (>) => { ::proc_macro::Punct::new('>', ::proc_macro::Spacing::Alone) };
    (&) => { ::proc_macro::Punct::new('&', ::proc_macro::Spacing::Alone) };
    (=) => { ::proc_macro::Punct::new('=', ::proc_macro::Spacing::Alone) };
    (:) => { ::proc_macro::Punct::new(':', ::proc_macro::Spacing::Alone) };
    (~) => { ::proc_macro::Punct::new('~', ::proc_macro::Spacing::Alone) };
    ($ident:ident) => { ::proc_macro::Ident::new(stringify!($ident), ::proc_macro::Span::mixed_site()) };
}
